% Blaise Pascal University
% Harris.m (Harris corner detector)
%%%%%%%%%%%
function [x,y]=harris_func(I)
%[x,map]=imread('test1.jpg');               
%I=double(x(:,:,1)); % keep red component
%% Compute Harris Score Map
Wx= [-1 0 1 ; -2 0 2 ;-1 0 1];
Wy= Wx';
Ix = masqn(I,Wx); % convolution
Iy = masqn(I,Wy);
Ixx = Ix.*Ix;
Iyy = Iy.*Iy;
Ixy = Ix.*Iy;
% windowing
WIxx = masqn(Ixx,gau(2,7));% sigma=2 
WIyy = masqn(Iyy,gau(2,7));% sigma=2 
WIxy = masqn(Ixy,gau(2,7));% sigma=2 
% Determinant and trace 
% R= D-k*trace^2  (l1*l2 - k* (l1+l2)^2)
D = WIxx.*WIyy-WIxy.*WIxy;
tr = WIxx+WIyy;
% Compute R
k = 0.04;
R = D - k.*(tr.^2);
%% Compute Interest Points
% Threshold 
R = R.* (R>0.03*max(R(:)));
% Find local maximum
R2 = masqn(R,[-1 0 0 ; 0 1 0 ; 0 0 0 ])>0 & ...
    masqn(R,[0 -1 0 ; 0 1 0 ; 0 0 0 ])>0 & ...
    masqn(R,[0 0 -1 ; 0 1 0 ; 0 0 0 ])>0 & ...
    masqn(R,[0 0 0 ; -1 1 0 ; 0 0 0 ])>0 & ...
    masqn(R,[0 0 0 ; 0 1 -1 ; 0 0 0 ])>0 & ...
    masqn(R,[0 0 0 ; 0 1 0 ; -1 0 0 ])>0 & ...
    masqn(R,[0 0 0 ; 0 1 0 ; 0 -1 0 ])>0 & ...
    masqn(R,[0 0 0 ; 0 1 0 ; 0 0 -1 ])>0;
% get x,y interest points coordinates
[y,x,tmp]=find(R2);
%% Display
% subplot(2,2,1)
% image(I);
% colormap(gray(256));
% hold on 
% plot(x,y,'+g');
% hold off
% title('original image');
% subplot(2,2,2)
% imagesc(R); % image scale
% title('Thresholded  Harris score')
% subplot(2,2,3)
% imagesc(R2); % image scale
% title('Thresholded  Harris score')

%% sub-functions
function W=gau(sigma,ta)
W=zeros(ta);
ta2=(ta-1)/2;
for i= -ta2:ta2
    for j= -ta2:ta2
        W(i+ta2+1,j+ta2+1)=exp(-(i^2+j^2)/(2*sigma^2));
    end
end
W = W./sum(W(:));

% Apply kernel m on image I. 
function [I2]=masqn(I,m)

[ty,tx]=size(m);
[Ity, Itx]=size(I);
I2=0.*I;
tmpx=round((tx-1)/2);
tmpy=round((ty-1)/2);
I=[I(1:tmpy,:) ; I ; I(Ity-tmpy+1:Ity,:)];
I=[I(:,1:tmpx) I I(:,Itx-tmpx+1:Itx)];
% 
for i=1:ty  
    for j=1:tx 
        I2=I2+m(i,j).*I(i:end-ty+i,j:end-tx+j);
    end
end
